#%RAML 1.0
---
title: Kavak Music Challenge
baseUri: https://kava-music-challenge.visomi.dev

traits:
  secured:
    usage: Apply this to any method that needs to be secured
    description: Some requests require authentication.
    headers:
      authorization:
        description: Access Token
        example: eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ1c2VyIjoiNWRjMzYxMjBkZDc5MTMyNzVkMjMzNDBkIiwiY29tcGFueSI6IjVkYzM2MTIwZGQ3OTEzMjc1ZDIzMzQwYyIsImlhdCI6MTU3MzE1MTMxMiwiZXhwIjoxNTczMjM3NzEyfQ.f3xFI0rVZFfa559Zl3_hb6VNtt8p48Ezl5NCct96IEA
        required: true
  paginated:
    usage: Apply this trait to a GET method that supports pagination.
    queryParameters:
      size:
        description: The `size` parameter restricts the number of entries returned.
        type: integer
        default: 20
        minimum: 1
        example: 20
      page:
        description: The `page` parameter specifies the page of results to return.
        type: integer
        default: 1
        minimum: 1
        example: 1
  sorted:
    usage: Apply this trait to a GET method that supports sortBy.
    queryParameters:
      sortBy?:
        description: The `sortBy` parameter sorting the restul for the fields provided.
        type: string
        default: id
        example: sortBy=id&sortBy=name
      sortByDir?:
        description: The `sortByDir` parameter specifies the direction for sorting.
        type: string
        enum: ['DESC', 'ASC']
        default: DESC
        example: ASC

/countries: !include countries/countries.raml
/users: !include users/users.raml
/albums: !include albums/albums.raml
/tracks: !include tracks/tracks.raml

